/* Exemplet visar specifikation av drag- och drop-element
   samt vilka händelser som inträffar för respektive element
   under en operation med drag-and-drop. */
// --------------------------------------------------
// Globala variabler och konstanter
let msgElem; // Elementet för meddelande
// --------------------------------------------------
// Initiering då webbsidan är inläst
function init() {
    msgElem = document.querySelector("#message");

    let dragElems = document.querySelectorAll("#dragItems div");
    for (let i = 0; i < dragElems.length; i++) {
        dragElems[i].draggable = true; // Tillåt att elementet dras
        dragElems[i].addEventListener("dragstart", dragItem);
        //dragElems[i].addEventListener("drag", dragItem);
        dragElems[i].addEventListener("dragend", dragItem);
    }

    let dropElems = document.querySelectorAll("#dropZones div");
    for (let i = 0; i < dropElems.length; i++) {
        dropElems[i].addEventListener("dragover", dropZone);
        dropElems[i].addEventListener("dragenter", dropZone);
        dropElems[i].addEventListener("dragleave", dropZone);
        dropElems[i].addEventListener("drop", dropZone);
    }
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Hantera händelser för det element som dras
function dragItem(e) {
    msgElem.innerHTML += e.type + " - ";
} // Slut dragItem
// --------------------------------------------------
// Hantera händelser för drop zones
function dropZone(e) {
    e.preventDefault(); // Tillåt att elementet kan droppas
    msgElem.innerHTML += e.type + " - ";
} // Slut dropZone
// --------------------------------------------------
