/* Koden kan struktureras på olika sätt. Detta är ett första alternativ,
   där det används varsin funktion för dragstart och dragend. För dragover,
   dragenter, dragleave och drop används en gemensam funktion, där man
   skiljer på de olika händelserna i en switch-sats. Anledningen till att
   ha en gemensam funktion är att det kan finnas en del kod i början som
   ska gälla för alla fyra händelserna. Det kommer vi se i senare exempel. */
// --------------------------------------------------
// Globala variabler och konstanter
let msgElem;    // Elementet för meddelande
let dropElems;  // Array med element som är "drop zones"
let dragElem;   // Element som användaren drar
// --------------------------------------------------
// Initiering då webbsidan är inläst
function init() {
    msgElem = document.querySelector("#message");
    let dragElems = document.querySelectorAll("#dragItems div");
    for (let i = 0; i < dragElems.length; i++) {
        dragElems[i].draggable = true;
        dragElems[i].addEventListener("dragstart", dragStart);
        dragElems[i].addEventListener("dragend", dragEnd);
    }
    dropElems = document.querySelectorAll("#dropZones div");
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Påbörja en drag-operation
function dragStart(e) {
    msgElem.innerHTML += e.type + " - ";
    dragElem = this; // Det element som dras, (funkar även med e.currentTarget istället för this)
    for (let i = 0; i < dropElems.length; i++) {
        dropElems[i].addEventListener("dragover", dropZone);
        dropElems[i].addEventListener("dragenter", dropZone);
        dropElems[i].addEventListener("dragleave", dropZone);
        dropElems[i].addEventListener("drop", dropZone);
    }
} // Slut dragStart
// --------------------------------------------------
// Avsluta drag-operationen
function dragEnd(e) {
    msgElem.innerHTML += e.type + " - ";
    for (let i = 0; i < dropElems.length; i++) {
        dropElems[i].removeEventListener("dragover", dropZone);
        dropElems[i].removeEventListener("dragenter", dropZone);
        dropElems[i].removeEventListener("dragleave", dropZone);
        dropElems[i].removeEventListener("drop", dropZone);
    }
} // Slut dragEnd
// --------------------------------------------------
// Hantera händelser för drop zones
function dropZone(e) {
    msgElem.innerHTML += e.type + " - ";
    e.preventDefault();
    let dropElem = this; // Det element som man drar över eller släppt på, (funkar även med e.currentTarget)
    switch (e.type) {
        case "dragover": // Behövs ofta ingen åtgärd
            // Men funktionen behöver anropas på "dragover" så att preventDefault() utförs
            break;
        case "dragenter": // Visuell feedback som visar att man är över en drop zone
            break;
        case "dragleave": // Ta bort visuell feedback
            break;
        case "drop":  // Gör vad som ska ske då man släpper på en drop zone
            // Här kanske man gör något både med dragElem och dropElem
    } // Slut switch
} // Slut dropZone
// --------------------------------------------------
