/* I detta alternaitiv grupperas funktionerna för drag-and-drop
   i funktionen för dragstart. Funktionerna dragEnd och dropZone
   ligger alltså som underfunktioner i funktionen dragStart.
   Detta gör att de lokala variabler som införs i dragStart även är
   tillgängliga i dragEnd och ddropZone. */
// --------------------------------------------------
// Globala variabler och konstanter
let msgElem;    // Elementet för meddelande
// --------------------------------------------------
// Initiering då webbsidan är inläst
function init() {
    msgElem = document.querySelector("#message");
    let dragElems = document.querySelectorAll("#dragItems div");
    for (let i = 0; i < dragElems.length; i++) {
        dragElems[i].draggable = true;
        dragElems[i].addEventListener("dragstart", dragStart);
    }
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Hantera en drag-operation
function dragStart(e) {
    msgElem.innerHTML += e.type + " - ";
    let dragElem = this; // Det element som dras, (funkar även med e.currentTarget istället för this)
    let dropElems = document.querySelectorAll("#dropZones div"); // Array med "drop zones"
    dragElem.addEventListener("dragend", dragEnd);
    for (let i = 0; i < dropElems.length; i++) {
        dropElems[i].addEventListener("dragover", dropZone);
        dropElems[i].addEventListener("dragenter", dropZone);
        dropElems[i].addEventListener("dragleave", dropZone);
        dropElems[i].addEventListener("drop", dropZone);
    }
    // ----------
    // Avsluta drag-operationen
    function dragEnd(e) {
        msgElem.innerHTML += e.type + " - ";
        dragElem.removeEventListener("dragend", dragEnd);
        for (let i = 0; i < dropElems.length; i++) {
            dropElems[i].removeEventListener("dragover", dropZone);
            dropElems[i].removeEventListener("dragenter", dropZone);
            dropElems[i].removeEventListener("dragleave", dropZone);
            dropElems[i].removeEventListener("drop", dropZone);
        }
    } // Slut dragEnd
    // ----------
    // Hantera händelser för drop zones
    function dropZone(e) {
        msgElem.innerHTML += e.type + " - ";
        e.preventDefault();
        let dropElem = this; // Det element som man drar över eller släppt på, (funkar även med e.currentTarget)
        switch (e.type) {
            case "dragover": // Behövs ofta ingen åtgärd
                // Men funktionen behöver anropas på "dragover" så att preventDefault() utförs
                break;
            case "dragenter": // Visuell feedback som visar att man är över en drop zone
                break;
            case "dragleave": // Ta bort visuell feedback
                break;
            case "drop":  // Gör vad som ska ske då man släpper på en drop zone
                // Här kanske man gör något både med dragElem och dropElem
        } // Slut switch
    } // Slut dropZone
    // ----------
} // Slut dragStart
// --------------------------------------------------
